# Development branch!

Please use the `toby_rewrite_3` branch for production use for the time being.


# Toby

Toby is a TurtleGraphics language and learning environment, similar, in many
ways, to LOGO. You have a cute triangle that you move around the screen with
simple commands: go forward, turn right, etc. With these commands you can
construct fascinating games, works of art, and outlets of expression. It's
fascinating and useful for everyone from early childhood to late adulthood.

TurtleGraphics have been noted by many psychologists and educators to be a
powerful aid in teaching geometry, spatial perception, logic skills, computer
programming, and art. Toby builds on the work of LOGO by cleaning up the
syntax of the programming language itself, enabling students to dive into
the software more easily, while at the same time giving them a better lesson
in what clean, maintainable software looks like.

It may seem a bit intimidating to boast that a software package can be aimed
at such a large age group, and be a good teaching device that also happens
to better prepare students for high-paying technical jobs, but it's true; the
value of TurtleGraphics are undisputably enriching in many fields.

Toby adheres to a simple paradigm:

- You're never too old to learn.
- You're never too young, either.
- Learning should always be interesting, or you won't learn.
- Learning is best done gradually.

For many years, one of the development goals of Toby has been cross-platform
support. A program is of no use if it won't run on your computer. To that end,
the current stable release of Toby is written in Java 1.2, which allows it to
run on most computers and operating systems, whether you have an iMac or a
Windows box or Linux running on a Sparc mainframe.

The current development version of Toby, however, is a rewrite (rewrite #5, to
be specific) in C and C++. The goal is more flexibility and performance speed
without a loss in portability. Indeed, we are targeting platforms that have no
Java support in the first place. The vision of being able to use Toby on your
Palm Pilot will be realized yet.  :)

Toby's educational value does not stop with the program; all versions of Toby
are available in source code form, so the advanced (and the curious) may poke
around under the hood to see what makes Toby tick.

The best source of documentation right now is myself; do not hesistate to email
me with questions about the installation, the program itself, or the philosophy
behind it. I love email. :)

--ryan.

icculus@icculus.org

